package com.zanxiang.game.back.serve.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.back.serve.dao.mapper.GameTencentAppOrderSplitLogMapper;
import com.zanxiang.game.back.serve.pojo.entity.GameTencentAppOrderSplitLog;
import com.zanxiang.game.back.serve.pojo.vo.GameTencentAppOrderSplitLogVO;
import com.zanxiang.game.back.serve.service.IGameTencentAppOrderSplitLogService;
import com.zanxiang.module.util.NumberUtil;
import com.zanxiang.module.util.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class GameTencentAppOrderSplitLogServiceImpl extends ServiceImpl<GameTencentAppOrderSplitLogMapper, GameTencentAppOrderSplitLog>
        implements IGameTencentAppOrderSplitLogService {

    @Override
    public List<GameTencentAppOrderSplitLogVO> listByOrderNo(Collection<String> orderNos) {
        if (CollectionUtils.isEmpty(orderNos)) {
            return Collections.emptyList();
        }
        return list(new LambdaQueryWrapper<GameTencentAppOrderSplitLog>()
                .in(GameTencentAppOrderSplitLog::getOrderNo, orderNos)
                .orderByAsc(GameTencentAppOrderSplitLog::getBackIndex)
        ).stream().map(this::toVOSimple).collect(Collectors.toList());
    }

    private GameTencentAppOrderSplitLogVO toVOSimple(GameTencentAppOrderSplitLog log) {
        if (log == null) {
            return null;
        }
        GameTencentAppOrderSplitLogVO vo = BeanUtil.copy(log, GameTencentAppOrderSplitLogVO.class);
        if (log.getSplitMoney() != null) {
            vo.setSplitMoney(NumberUtil.divide100(new BigDecimal(log.getSplitMoney())));
        }
        return vo;
    }
}
